USE DVDClub;

IF OBJECT_ID('averageRating', 'FN') IS NOT NULL
BEGIN
DROP FUNCTION averageRating;
PRINT 'Function averageRating deleted!';
END
GO

CREATE FUNCTION averageRating
(
  @GenreName NVARCHAR(50)
)
RETURNS FLOAT
AS
BEGIN
RETURN (SELECT AVG(Rating) FROM Movie
        WHERE EXISTS (SELECT * FROM MovieGenre 
                      WHERE MovieGenre.MovieID = Movie.ID AND
                            MovieGenre.GenreName = @GenreName));
END

GO

PRINT 'Function averageRating created!';