; Primer 1.
;
; f(x) = y /\ g(y) = x /\ x != g(f(x))

; Sintaksa:
; (set-logic <ime_logike>)
; (declare-sort <simbol> <arnost>)
; (declare-fun <simbol> (<sorta>*) <sorta>)
; (assert <formula>)
; (check-sat)
; (exit)
; <formula> ::= (<operator> <formula>+) | <simbol> | <konstanta> | true | false
; <operator> ::= and | or | not | => | = | distinct
; <operator> takodje moze biti neki od definisanih funkcijskih simbola.
; <simbol> je neki od funkcijskih simbola koji ima praznu listu sorti argumenata
; <konstanta> je ili numeral (npr. 4) ili decimalna konstana (npr 2.1)
; ili razlomak (npr. (/ 2 3))
; neke od logika koje su dopustene su QF_UF, QF_LRA, QF_LIA, QF_UFLIA, QF_UFLRA, ...
(set-logic QF_UF)
(declare-sort S 0)
(declare-fun x () S)
(declare-fun y () S)
(declare-fun f (S) S)
(declare-fun g (S) S)
(assert
  (and (= (f x) y) (= (g y) x) (distinct x (g (f x))) )
)
(check-sat)
(exit)
